<template lang='pug'>
  section.space-bg
    .container
      .wrapper
        BaseText.title.space-mdl(size='text-bg') Кошелёк криптовалют
        .container-coins.purse-coins-space-bottom(v-if='coins > 0')
          img.coin(src='../../assets/img/coin.png'
            v-for='coin in coins'
            v-bind:style='[ { right: 10 * (coin-1) + "px" }, { zIndex: -coin } ]')
        BaseText.num-of-coins.purse-num-of-coins-space-bottom(size='text-bg-md' skin='grey' weight='bold') {{coins}} biorobo {{strNumOfCoins}}
        button.get-out-coins(
          class='get-out-сoins'
          @click='getOut'
          :class='{"get-out-coins-disabled": isCantGettingOut}'
        ) Нацыганить
        label.label(value = 'true' v-model = 'isGrow') Цыганить по {{GROW}} монет
          input.input(type='checkbox' value = 'true' v-model = 'isGrow')
      ModalCoins(
        v-if='isShowModal'
        isShowModal=isShowModal
        @onClose='onClose'
      )
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'

import { PurseModule } from '../../store/modules/purse/index'
import { ProductionModule } from '../../store/modules/production/index'
import ModalCoins from '../ModalCoins.vue'
import BaseText from '../BaseText.vue'
import declOfNum from '../../utils/declOfNum'

@Component({
  components: {
    BaseText,
    ModalCoins
  }
})
export default class Purse extends Vue {
  isShowModal: boolean = false
  isGrow: boolean = false
  GROW = 10

  get details () {
    return ProductionModule.details
  }

  get coins () {
    return PurseModule.coins
  }

  get strNumOfCoins () {
    return declOfNum(this.coins, ['монета', 'монеты', 'монет'])
  }

  get isCantGettingOut (): boolean {
    if (this.isGrow) {
      return this.isGrow ? this.coins > 100 - this.GROW : this.coins >= 100
    }
    return this.coins >= 100
  }

  getOut () {
    if (!this.isCantGettingOut) {
      PurseModule.addCoins(this.isGrow === true ? this.GROW : 1)
    } else {
      this.isShowModal = !this.isShowModal
    }
  }

  onClose () {
    this.isShowModal = false
  }
}
</script>

<style lang='scss' scoped>
@import '../../assets/styles/config/variables.scss';

.wrapper {
  display: grid;

  grid-template-columns: repeat(8, 1fr);
  column-gap: 24px;
}

.title, .num-of-coins {
  grid-column: 2 / 6;
}

.container-coins {
  grid-column: 2 / 9;
  white-space: nowrap;
}

.coin {
  position: relative;
  width: $coin-width;
  height: $coin-height;
}

.get-out-сoins {
  grid-column: 2 / 3;
  border: 0;
  background: none;
  border-bottom: 0.5px $main-orange-color solid;

  color: $main-orange-color;
  font-weight: 500;
  font-size: 16px;
  line-height: 24px;

  cursor: pointer;
}

.get-out-coins-disabled {
  color: $disable-button-background-color;
}

.input {
  width: 22px;
  height: 22px;

  grid-column: 3 / 4;

  position: relative;

  margin-right: 12px;
  margin-left: 2px;
  margin-bottom: 2px;

  float: left;

  -webkit-appearance: none;
  background: transparent;

  outline: 2px solid $cost-color;
  vertical-align: -6px;

  &:checked {
    -webkit-appearance: none;
    background: url('../../assets/img/input.png') no-repeat;
    background-position: center;
    outline: 2px solid $cost-color;
  }
  &:disabled {
    outline: 2px solid $disable-button-background-color;
  }
}

.label {
  grid-column: 3 / 5;
  position: relative;
  top: 0px;
  font-weight: 500;
  font-size: 16px;
  line-height: 24px;
}

</style>
